/*
*******************************************************************************
*  Copyright (c) 1996 Martin Poole                            *
*******************************************************************************
**
*/

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <pwd.h>
#include <time.h>
#include <string.h>
#include <stdarg.h>
#include <memory.h>

#include <mplib1/mplib1_config.h>
#include <mplib1/timestamp.h>
#include <mplib1/fprintfile.h>

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

int
fprintfile( FILE *fp, const char *format, ... )
{
    int rv;
    va_list ap;

    /* put the time string on the front */
    fput_log_str( fp );

    /* now send the rest of the string */
    va_start( ap, format );
    rv = vfprintf( fp, format, ap );
    va_end( ap );

    return( rv );
}

/* -- End of File -- */
