/*
*******************************************************************************
*  Copyright (c) 1996 Martin Poole                            *
*******************************************************************************
**
*******************************************************************************
*/

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <mplib1/mplib1_config.h>

#include <mplib1/mpbasename.h>

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

/* ---------------------------------------------------------------------------
   Function                 : mpbasename
   Summary                  : This function returns a pointer to the base name
                            : of the filename given
   Input Parameters         : pointer to a filename
   Output Parameters        : None
   Global Variables         : None
   Return Value             : pointer to basename of filename
   --------------------------------------------------------------------------*/
char *
mpbasename ( const char *full_name )
{
    const char *cp;

    cp = full_name + strlen(full_name) - 1;
    while ( cp > full_name && *cp != '/' ) cp --;
    if ( *cp == '/' ) cp++;
    return((char *)(size_t)cp);
}



/* -- End of File -- */
