/*
*******************************************************************************
*  Copyright (c) 1996 Martin Poole                            *
*******************************************************************************
**
*******************************************************************************
*/

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#include <stdlib.h>
#include <memory.h>
#include <string.h>

#include <mplib1/mplib1_config.h>
#include <mplib1/mpstrtok.h>

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

struct strtok
{
char *str_st;
char *str_end;
char *str_nxt;
};


/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */


char *
mpstrtok( char *str, void **ftok, const char *seps )
{
    struct strtok *tok= *ftok;
    char *cp,*cp2;

    if (str)
    {
	/* first call, set things up and give first details */
	tok = (struct strtok *)malloc(sizeof(struct strtok));
	*ftok = tok;
	if (tok == NULL)
	    return(NULL);

	tok->str_st = str;
	tok->str_end = str + strlen(str);
	tok->str_nxt = str;

    }else if (tok==NULL)
	return(NULL);

    if (seps==NULL)
    {
	/* early termination, free memory */
	free(tok);
	*ftok = NULL;
	return(NULL);
    }

    /* skip leading seperators */
    cp = tok->str_nxt;
    while (*cp && strchr(seps,*cp)) cp++;

    /* have we gone too far ? */
    if (cp >= tok->str_end)
    {
	free(tok);
	*ftok = NULL;
	return(NULL);
    }
    /* now mark the end of the string */
    cp2 = cp;
    while (*cp2 && strchr(seps,*cp2)==NULL) cp2++;
    tok->str_nxt = cp2 + ((*cp2)? 1 : 0);
    *cp2 = '\0';

    return(cp);
}

/* -- End of File -- */
