/*
*******************************************************************************
*  Copyright (c) 1996 Martin Poole                            *
*******************************************************************************
**
*******************************************************************************
*/

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <unistd.h>
#include <signal.h>
#include <fcntl.h>
#include <string.h>
#include <memory.h>
#include <stdlib.h>

#include <mplib1/mplib1_config.h>

#include "../include/bpo_internal.h"
#include <mplib1/bpo.h>

#include <mplib1/dl_list.h>
#include <mplib1/cfg_file.h>
#include <mplib1/fprintfile.h>

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

void *
bpo_send_and_get( const char *q_name,
		struct bpo_Q_Mesg *bpo_msg,
		struct bpo_Q *reply_q )
{
    void *rv=NULL;
    if (mpPostMsg( q_name, bpo_msg, reply_q )==1)
    {
        do
        {
            if (mpWaitQ( reply_q->Q_name, reply_q ) < 0)
                break;
            rv = mpGetMsg( reply_q->Q_name, reply_q );
        } while (rv==NULL && errno==0);
    }
    return( rv );
}



/* -- End of File -- */
