
Summary:	Library of low-level C utilities (list, jobs, parsing)
Name:		mplib1
Version:	4.2.0
Release:	1
License:	GPL version 3 or any later version
Group:		System Environment/Libraries
URL:		http://quatermass.co.uk/toolsmith/mplib1/
Source0:	%name-%version.tgz

BuildRoot:	%_tmppath/%name-%version-%release-root

Requires:	gdbm
BuildRequires:	gdbm-devel


%package utils
Summary:	Support utilties for mplib1
Group:		Applications/File
Requires:	%name
# Prevent version mix
Conflicts:	%name < %version-%release
Conflicts:	%name > %version-%release

%package devel
Summary:	Header files and libraries for mplin1 utilities
Group:		Development/Libraries
Requires:	mplib1


%description
mplib1 is a collection of C library functions for list handling, interactive
command line parsing, shared memory routines

%description utils
This package provides a number of command line utilties for interacting
with programs written to use mplib1

%description devel
This package contains headerfiles and libraries which are needed to
build applications using mplib1.

## ------------------------------------------------------------

%prep
%setup -q -n %{name}-%{version}%{?prerelease}


## ------------------------------------------------------------

%build

make PLATFORM=linux_26

make


## ------------------------------------------------------------

%install
#rm -rf "$RPM_BUILD_ROOT" _doc*
#make DESTDIR="$RPM_BUILD_ROOT" install

install -d -m755 \
	${RPM_BUILD_ROOT}%_libdir
install -m644 lib/*.so ${RPM_BUILD_ROOT}%_libdir

install -d -m755 \
	${RPM_BUILD_ROOT}%_bindir
install -m755 bin/* ${RPM_BUILD_ROOT}%_bindir

install -d -m755 \
	${RPM_BUILD_ROOT}%_includedir/mplib1
install -m644 mplib1/*.h ${RPM_BUILD_ROOT}%_includedir/mplib1


## ------------------------------------------------------------

%clean
rm -rf "$RPM_BUILD_ROOT"

## ------------------------------------------------------------

%post
/sbin/ldconfig

%postun
/sbin/ldconfig


## -----------------------

%files
%defattr(-,root,root,-)
%_libdir/*.so

## -----------------------

%files utils
%defattr(-,root,root,-)
%_bindir/*
%doc util_doc/*

## -----------------------

%files devel
%defattr(-,root,root,-)
%_includedir/*
%_libdir/*.so
%doc doc/*

## -----------------------

%changelog
* Sun Dec 09 2012 Martin Poole <mpoole@tidymail.co.uk> - 4.2.0-1
- Adjust bpo_q reply mech for resilience.
- Include updated GPL statement

* Sun Sep 23 2012 Martin Poole <mpoole@tidymail.co.uk>> - 4.1.0-1
- First cut at rpm build

