/*
*******************************************************************************
*  Copyright (c) 1996 Martin Poole                            *
*******************************************************************************
**
*******************************************************************************
*/

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/ipc.h>

#include <mplib1/cfg_file.h>
#include <mplib1/bpo.h>

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

static void usage ( const char *progname, const char *errstr )
{
    if (errstr)
	fprintf( stderr, "Error: %s\n", errstr );
    fprintf(stderr,
	    "\nUsage: %s [ -f filename ] [ -d directory ]\n", progname );
    exit(1);
    return;
}

int
main (int argc, char *argv[] )
{
    char *cp=NULL;
    int optc;

    while ((optc = getopt(argc, argv, "d:f:")) != EOF)
    switch(optc)
    {
    case 'd' : /* Specify directory */
	cp = optarg;
	break;
    case 'f' : /* Specify config file */
	read_config_file(optarg);
	break;
    default:
	usage( argv[0], "Invalid argument supplied" );
	break;
    }

    if (cp==NULL || *cp=='\0')
	cp = eval_config_default( "PIPE_DIR", "$HOME/pipe" );
    scan_dead_pipes( cp );
    return(0);
}


/* -- End of File -- */
